/*
 *	assert.h
 */

#ifndef _ASSERT_
# define _ASSERT_

# ifdef XENIX

/*
 *	Xenix
 */

#  ifdef DEBUG
    static char Asrtstr[] = "Invalid assertion line %d of %s :%s\n";
#   define ASSERT(condition) {if (!(condition)) {\
		printf(Asrtstr, __LINE__, __FILE__, " condition ");\
		debug(0);\
	}\
}
#  else
#   define ASSERT(condition)	
#  endif

# else

/*
 *	BSD
 */

#  ifndef NDEBUG
    static char Asrtfail[] = "Assertion failed: file \"%s\", line %d\n";
#   define _assert(ex) {if (!(ex)) {\
		fprintf(stderr,Asrtfail, __FILE__, __LINE__);\
		exit(1);\
	}\
}
#   define assert(ex) _assert(ex)
#  else
#   define _assert(ex)
#   define assert(ex)
#  endif

# endif

#endif _ASSERT_
