/*
 *	ctype.h
 */

/*
 *	In order to get non-macro versions of toupper() and tolower(),
 *	do a #undef.  Non-macro versions are supplied in libc.
 */

#ifndef _CTYPE_
#define _CTYPE_

#define	_U	01
#define	_L	02
#define	_N	04
#define	_S	010
#define	_P	020
#define	_C	040
#define	_B	0100
#define	_X	0200

extern	char	_ctype[];

#define	isalpha(c)	((_ctype+1)[c]&(_U|_L))
#define	isupper(c)	((_ctype+1)[c]&_U)
#define	islower(c)	((_ctype+1)[c]&_L)
#define	isdigit(c)	((_ctype+1)[c]&_N)
#define	isxdigit(c)	((_ctype+1)[c]&_X)
#define	isspace(c)	((_ctype+1)[c]&_S)
#define	ispunct(c)	((_ctype+1)[c]&_P)
#define	isalnum(c)	((_ctype+1)[c]&(_U|_L|_N))
#define	isprint(c)	((_ctype+1)[c]&(_P|_U|_L|_N|_B))
#define	isgraph(c)	((_ctype+1)[c]&(_P|_U|_L|_N))
#define	iscntrl(c)	((_ctype+1)[c]&_C)
#define	isascii(c)	((unsigned)(c)<=0177)
#define	_toupper(c)	((c)-'a'+'A')
#define	_tolower(c)	((c)-'A'+'a')
#define	toupper(c)	(islower(c) ? _toupper(c) : (c))
#define	tolower(c)	(isupper(c) ? _tolower(c) : (c))
#define	toascii(c)	((c)&0177)

#endif _CTYPE_
