/*
 *	syspar.h
 */

#ifndef _SYSPAR_
#define _SYSPAR_

/*                             */
/*  system parameters          */
/*  ==================         */
/*                             */

/*	Modifications
 *
 *	M001	1985-10-08	JT
 *	Increased number of clist's from 32 to 256 for X35
 *
 */

#ifdef	DS90M10
#define	NRNODES		256	/* Number of nodes */
#define	NPROC		64	/* Maximum number of processes */
#define	MUPRC		12	/* Maximum number of processes for a user */
#define	NCLIST		64	/* Number of clists */
#define	NCALL		16	/* Number of entries in callout table */
#define	NBRFH		64	/* Number of buffers for root file handler */
#define	MAXMEM		1024	/* Max memory pages per process */
#define	NCTERM		24	/* Max number of controlling terminals */
#endif
#ifdef	DS60M10
#define	NRNODES		256	/* Number of nodes */
#define	NPROC		64	/* Maximum number of processes */
#define	MUPRC		12	/* Maximum number of processes for a user */
#define	NCLIST		64	/* Number of clists */
#define	NCALL		16	/* Number of entries in callout table */
#define	NBRFH		64	/* Number of buffers for root file handler */
#define	MAXMEM		1024	/* Max memory pages per process */
#define	NCTERM		24	/* Max number of controlling terminals */
#endif
#ifdef	DS90NS32000
#define	NRNODES		256	/* Number of nodes */
#define	NPROC		64	/* Maximum number of processes */
#define	MUPRC		12	/* Maximum number of processes for a user */
#define	NCOREL		4096	/* Number of pages of memory - for page table*/
#define	NCLIST		64	/* Number of clists */
#define	NCALL		16	/* Number of entries in callout table */
#define	NBRFH		128	/* Number of buffers for root file handler */
#define	MAXMEM		4016	/* Max memory pages per process */
#define	NCTERM		24	/* Max number of controlling terminals */
#endif
#ifdef	X35
#define	NRNODES		128	/* Number of nodes in the system */
#define	NPROC		40	/* Maximum number of processes */
#define	MUPRC		8	/* Max number of processes for a user */
#define	NCLIST		256	/* Number of clists */ /* M001 */
#define	NCALL		8	/* Number of entries in callout table */
#define	NBRFH		8	/* Number of buffers for root file handler */
#define	MAXMEM		512	/* Max memory pages per process */
#define	NCTERM		18	/* Max number of controlling terminals */
#endif

#define	NOFILE	24		/* Number of lu-s per process */

#define	NRASDN	((NPROC-1)*4)	/* Number of asd nodes */

#define	NULL	0		/* NULL pointer */

#define	NPRILEV	16		/* Number of priority levels */
#define	HPRINSU	4		/* Highes priority level for non super */
#define	PRIINIT	3		/* Priority of init process */

#define	NSIG	18		/* Number of signals */
#define	MASKSIG	0x1ffffL	/* Mask for signal bit vector */

#define	MNCARGS	5120		/* Maximum number of characters in exec args */

#define	STMBSIZE	64	/* Size of streaming buffer */
#define	STMSSL		24	/* Start streaming level */

/*
 *      Timeslice = Slice * 2 ** min(4,dympri-maxpri)
 *      For the time beeing we set it to Slice
 */

#define	TIMESLICE(dm)	(Slice)  

#endif _SYSPAR_
