/*
 *	types.h
 */

#ifndef _TYPES_
#define _TYPES_

typedef char *		laddr_t;	/* Logical core address */
typedef	long		time_t;		/* Time */
typedef	long		off_t;		/* Seek offset */
typedef	int		label_t[17];	/* d0-d7, a0-a7, sr */

/*
 * Typedef:s used by file system
 */

typedef	unsigned long	daddr_t;	/* Disk address */
typedef	unsigned short	ino_t;		/* I-node number */
typedef short		fd_t;		/* File descriptor */
typedef unsigned short	bksiz_t;	/* Disk block size */

/*
 *	Typedef:s used by drivers
 */

typedef	short		dev_t;		/* Device type */
typedef unsigned char	uchar_t;	/* Unsigned char. */

/* Major part of device */

#define	major(x)	(int)(((unsigned)(x)>>8) & 0xf)

/* Blocked device */

#define	blkdev(x)	((unsigned)(x) & 8192)

/* Minor part of device */

#define	minor(x)	(int)((x)&0377)

/* Make a device number */

#define	makedev(x,y)	(dev_t)((x)<<8 | (y))

#endif _TYPES_
