/*
 *	values.h
 *	limits.h
 */

#ifndef _VALUES_
#define _VALUES_

#define	BITSPERBYTE	8

/*
** constants with only the high bit set
*/

#define	HIBITS		0x8000
#define	HIBITI		0x80000000
#define	HIBITL		0x80000000

/*
** largest value for each type
*/

#define	MAXSHORT	32767
#define	MAXINT		2147418112
#define	MAXLONG		2147418112

/*
** smallest value for each type (assumes 2's complement representation)
*/

#define	MINSHORT	HIBITS
#define	MININT		HIBITI
#define	MINLONG		HIBITL

/*
** similar #defines for ANSI compatibility
*/

#define	CHAR_BIT	BITSPERBYTE
#define	SCHAR_MAX	(127)
#define	SCHAR_MIN	(-128)
#define	CHAR_MAX	SCHAR_MAX
#define	CHAR_MIN	SCHAR_MIN

#define	SHRT_MAX	MAXSHORT
#define	SHRT_MIN	MINSHORT

#define	INT_MAX		MAXINT
#define	INT_MIN		MININT

#define	LONG_MAX	MAXLONG
#define	LONG_MIN	MINLONG

#define	UCHAR_MAX	~((unsigned char) 0)
#define	USHRT_MAX	~((unsigned short) 0)
#define	UINT_MAX	~((unsigned int) 0)
#define	ULONG_MAX	~((unsigned long) 0)

/*
** floating limits :-)
*/

#define	DMAXEXP		2047
#define	FMAXEXP		127
#define	DMINEXP		0
#define	FMINEXP		0
#define	MAXDOUBLE	1.79769313486232E308
#define	MAXFLOAT	1.70141E38
#define	MINDOUBLE	4.4501477170144E-308
#define	MINFLOAT	2.93874E-39
#define	DSIGNIF		52
#define	FSIGNIF		23
#define	DMAXPOWTWO	1024
#define	FMAXPOWTWO	128
#define	_FEXPLEN	7
#define	_EXPBASE	2
#define	_DEXPLEN	10
#define	_IEEE		1
#define	_LENBASE	1
#define	HIDDENBIT	1
#define	LN_MAXDOUBLE	709
#define	LN_MINDOUBLE	-707

#endif _VALUES_
