/*
 *	malloc.h
 */

/*
 *	Definitions for the malloc(OS) routine
 */

#ifndef _MALLOC_
#define _MALLOC_

#define	M_MXFAST	0
#define	M_NLBLKS	1	/* Set number of blocks in a holding block */
#define	M_GRAIN		2	/* Set number of size mapped to one */
#define	M_KEEP		3	/* Retain contents of blocks after a free */

struct mallinfo {
	int	arena;		/* Total space in arena */
	int	ordblks;	/* Number of ordinary blocks */
	int	smblks;		/* Number of small blocks */
	int	hblks;		/* Number of holding blocks */
	int	hblkhd;		/* Space in holding block headers */
	int	usmblks;	/* Space in small blocks in use */
	int	fsmblks;	/* Space in free small blocks */
	int	uordblks;	/* Space in ordinary blocks in use */
	int	keepcost;	/* Cost of enabling keep option */
};

#endif _MALLOC_
