/*
 *	pwd.h	1.1
 */

#ifndef _PWD_
#define _PWD_

struct passwd {	/* see getpwent(3) */
	char	*pw_name;	/* login name */
	char	*pw_passwd;	/* encrypted password */
	int	pw_uid;		/* numerical user ID */
	int	pw_gid;		/* numerical group ID */
	int	pw_quota;	/* Max user disk usage. */
	char	*pw_age;	/* data for password aging, see below */
	char	*pw_comment;
	char	*pw_gecos;
	char	*pw_dir;	/* initial working directory */
	char	*pw_shell;	/* program to use as shell */
};

/*
 *	Characters for pw_passwd and 'digits' for pw_age taken from
 *	the 64 character alphabet (., /, 0-9, a-z, A-Z).
 *
 * pw_age field:
 *	Mmc...c
 *	M	= maximum number of weeks for which password is valid.
 *	m	= minimum period in weeks which must expire before
 *		  password may be changed.
 *	c...c	= week (counted from 'the epoch') when password was last
 *		  changed.
 */

struct passwd *getpwent(), *getpwuid(), *getpwnam();

#endif _PWD_
