/*
 *	ioctl.h
 */

#ifndef _IOCTL_
#define _IOCTL_

#define	IOCTYPE	0xff00

/*
 *	tty driver control (sysV)
 */

#define	TIOC      ('T'<<8)
#define	TCGETA    (TIOC|1)	/* get attributes */
#define	TCSETA    (TIOC|2)	/* set attributes */
#define	TCSETAW   (TIOC|3)	/* wait and set attributes */
#define	TCSETAF   (TIOC|4)	/* flush and set attributes */
#define	TCSBRK    (TIOC|5)	/* send break */
#define	TCXONC    (TIOC|6)	/* start/stop output */
#define	TCFLSH    (TIOC|7)	/* flush */
#define	TCDSET    (TIOC|32)	/* ??? */

/*
 *	?
 */

#define	LDIOC     ('D'<<8)
#define	LDOPEN    (LDIOC|0)
#define	LDCLOSE   (LDIOC|1)
#define	LDCHG     (LDIOC|2)

/*
 *	tty driver control (V7 and BSD)
 */

#ifndef tIOC
# define tIOC      ('t'<<8)
# define TIOCGETD  (tIOC|0)	/* get line discipline */		/* V7 */
# define TIOCSETD  (tIOC|1)	/* set line discipline */		/* V7 */
# define TIOCHPCL  (tIOC|2)	/* set hangup line on close bit */	/* V7 */
# define TIOCGETP  (tIOC|8)	/* get parameters - like old gtty */
# define TIOCSETP  (tIOC|9)	/* set parameters - like old stty */
# define TIOCSETN  (tIOC|10)	/* set parameters w/o flushing buffs */	/* V7 */
# define TIOCEXCL  (tIOC|13)	/* set exclusive use of tty */		/* V7 */
# define TIOCNXCL  (tIOC|14)	/* reset exclusive use of tty */	/* V7 */
# define TIOCFLUSH (tIOC|16)	/* flush buffers */			/* V7 */
# define TIOCSETC  (tIOC|17)	/* set special characters */		/* V7 */
# define TIOCGETC  (tIOC|18)	/* get special characters */		/* V7 */
#endif tIOC

/*
 *	?
 */

#define	LIOC      ('l'<<8)
#define	LIOCGETP  (LIOC|1)
#define	LIOCSETP  (LIOC|2)
#define	LIOCGETS  (LIOC|5)
#define	LIOCSETS  (LIOC|6)

/*
 *	?
 */

#define	DIOC      ('d'<<8)
#define	DIOCGETC  (DIOC|1)
#define	DIOCGETB  (DIOC|2)
#define	DIOCSETE  (DIOC|3)
#define DIOCGETP  (DIOC|8)	/* line discipline ioctl */		/* V7 */
#define DIOCSETP  (DIOC|9)	/* line discipline ioctl */		/* V7 */

/*
 *	?
 */

#define	VPM       ('V'<<8)
#define	VPMCMD    (VPM|8)
#define	VPMERRS   (VPM|9)
#define	VPMRPT    (VPM|10)
#define	VPMTRCO   (VPM|16)

/*
 *	file control
 */

#ifndef fIOC
# define fIOC      ('f'<<8)
# define FIOCLEX   (fIOC|1)	/* close file on exec */
# define FIONCLEX  (fIOC|2)	/* do not close file on exec */
# define FIORDCHK  (fIOC|3)	/* check if read would block */		/* V7 */
#endif fIOC

#endif _IOCTL_
